<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\home_service;


use app\common\model\home_service\HomeSpecial;
use app\common\logic\BaseLogic;
use think\facade\Db;


/**
 * HomeSpecial逻辑
 * Class HomeSpecialLogic
 * @package app\adminapi\logic\home_service
 */
class HomeSpecialLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/11/18 10:05
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            HomeSpecial::create([
                'special_type' => $params['special_type'],
                'special_way'=>$params['special_way'],
                'title' => $params['title'],
                'cover_type' => $params['cover_type'],
                'cover' => $params['cover'],
                'describe' => $params['describe'],
                'content' => $params['content'],
                'goods_id' => $params['goods_id'],
                'user_head' => $params['user_head'],
                'user_nickname' => $params['user_nickname'],
                'vue_web' => $params['vue_web'],
                'vue_param' => $params['vue_param'],
                'weight' => $params['weight'],
                'view_num' => $params['view_num'],
                'tags' => $params['tags'],
                'original_price' => $params['original_price'],
                'present_price' => $params['present_price'],
                'status' => $params['status']
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/11/18 10:05
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            HomeSpecial::where('id', $params['id'])->update([
                'special_type' => $params['special_type'],
                'special_way'=>$params['special_way'],
                'title' => $params['title'],
                'cover_type' => $params['cover_type'],
                'cover' => $params['cover'],
                'describe' => $params['describe'],
                'content' => $params['content'],
                'goods_id' => $params['goods_id'],
                'user_head' => $params['user_head'],
                'user_nickname' => $params['user_nickname'],
                'vue_web' => $params['vue_web'],
                'vue_param' => $params['vue_param'],
                'weight' => $params['weight'],
                'view_num' => $params['view_num'],
                'tags' => $params['tags'],
                'original_price' => $params['original_price'],
                'present_price' => $params['present_price'],
                'status' => $params['status']
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/11/18 10:05
     */
    public static function delete(array $params): bool
    {
        return HomeSpecial::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2024/11/18 10:05
     */
    public static function detail($params): array
    {
        return HomeSpecial::findOrEmpty($params['id'])->toArray();
    }
}